<template functional>
  <div
    :ref="data.ref"
    class="frame"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <slot />
  </div>
</template>

<script>
export default {
  name: 'FramedItem',
};
</script>

<style lang="postcss">
.frame {
  --frame-n: 9;
  --frame-d: 16;

  padding-bottom: calc(var(--frame-n) / var(--frame-d) * 100%);
  position: relative;
}

.frame > * {
  @apply overflow-hidden absolute inset-0 flex justify-center items-center;
}

.frame > img,
.frame > video {
  @apply h-full w-full object-cover;
}
</style>
